Index: /trunk/seguranca/security.php
===================================================================
--- /trunk/seguranca/security.php	(revision 1035)
+++ /trunk/seguranca/security.php	(revision 1035)
@@ -0,0 +1,253 @@
+<?php
+	require_once('classes/CertificadoB.php');
+
+        $Linhas = explode(chr(0x0A),file_get_contents($_SERVER["DOCUMENT_ROOT"] . '/seguranca/crl_admin/crl_admin_confg.py'));
+	
+	foreach($Linhas as $linha)
+		{
+			$path = pega_path(array( 'arquivo =', 'arquivo='),$linha);
+			if($path) $path1 = $path;
+			$path = pega_path(array( 'log =', 'log='),$linha);
+			if($path) $path2 = $path;
+			$path = pega_path(array( 'CAfile =', 'CAfile='),$linha);
+			if($path) $path3 = $path;
+		}
+
+	if($path3)
+		{
+		$item = 1;
+		$todos_certificados =  ler_certificados_CAS($path3);
+		$aux_emissores= array();
+		$tab_certs = array();
+		$CB = new CertificadoB();
+		foreach($todos_certificados as $certificados)
+			{
+				$CB -> certificado($certificados);
+				$df = $CB->dados['FIM_VALIDADE'];
+				$di =  $CB->dados['INICIO_VALIDADE'];
+				if(gmdate("YmdHis") > $df)
+					{	
+						$cor = '<label style="color: #FF0000" >Expirado em: </label>';
+					}
+				else
+					{
+						$cor = '<label>Valido at&eacute; </label>';
+					}
+				$info = $cor . substr($df,0,4) . '/' . substr($df,4,2) . '/' . substr($df,6,2) . '  -  ' . substr($df,8,2) . ':' . substr($df,10,2) . ':' . substr($df,12,2) . ' GMT';
+				$info = '<font size="1"' . $info . '</font>';
+				// Armazena alguns dados do certificado. $tabs_certs esta na mesma ordem em que os certificados aparecem no arquivo todos.cer.....
+				$tab_certs[$CB->dados['SUBJECT']['CN']]['item'] = $item++;
+				$tab_certs[$CB->dados['SUBJECT']['CN']]['emissor'] =  $CB->dados['EMISSOR_CAMINHO_COMPLETO']['CN'];
+				$tab_certs[$CB->dados['SUBJECT']['CN']]['fim_validade'] = $info;
+				$tab_certs[$CB->dados['SUBJECT']['CN']]['inicio_validade'] = $di;
+				if($CB->dados['EMISSOR_CAMINHO_COMPLETO']['CN'] !=  $CB->dados['SUBJECT']['CN'])
+					{
+						// Se nao he um auto assinado (identifica um raiz), salva emissor , faz a chave a tdata de inicio de validade do certificado...
+						$aux_emissores[$di][$CB->dados['EMISSOR_CAMINHO_COMPLETO']['CN']][$CB->dados['SUBJECT']['CN']] = '9' ;
+					}
+			}
+                // ordena certificados pela data de inicio de validade ......			
+		ksort($aux_emissores);
+		$NOVO = array();
+		$AUX3 = array();
+		$emissores = array();
+
+		foreach($aux_emissores as $kchave1 => $emis1)
+			{
+				foreach($emis1 as $Kchave2 => $emis2)
+					{
+						foreach($emis2 as $Kchave3 => $emis3)
+							{
+									$emissores[$Kchave2][$Kchave3] = '9';
+							}
+					}
+			}
+
+		// O array $NOVO vai conter a cadeia dos certificados de CAs ....
+		foreach($emissores as $K => $V)
+			{
+			        if($AUX3[$K] != '0')
+				{
+					foreach($V as $K1 => $V1)
+						{
+									if($emissores[$K1])
+										{
+											$NOVO[$K][$K1] = $emissores[$K1];
+											$AUX3[$K1] = '0';
+										}
+									else
+										{
+											$NOVO[$K][$K1] = '0';
+										}
+						}	
+				}
+			} 
+		
+		// Valores auxiliares para fazer a identacao .....
+		$prefixo0 = '&nbsp;&nbsp;' . '|';
+		$prefixo1 =  '&nbsp;&nbsp;' .  '|' .  '____' ;
+		$prefixo2 =  '&nbsp;&nbsp;' . '|' .  '&nbsp;&nbsp;' . '&nbsp;&nbsp;' .  '&nbsp;&nbsp;' .  '&nbsp;&nbsp;' . '|' ;
+		$prefixo2A =  '&nbsp;&nbsp;' . '&nbsp;&nbsp;' .  '&nbsp;&nbsp;' . '&nbsp;&nbsp;' .  '&nbsp;&nbsp;' .  '&nbsp;&nbsp;' . '|' ;
+		$prefixo3 =  '&nbsp;&nbsp;' . '|' .  '&nbsp;&nbsp;' . '&nbsp;&nbsp;' .  '&nbsp;&nbsp;' .  '&nbsp;&nbsp;' . '|'  . '____' ;
+		$prefixo3A =  '&nbsp;&nbsp;' .  '&nbsp;&nbsp;'  .  '&nbsp;&nbsp;' . '&nbsp;&nbsp;' .  '&nbsp;&nbsp;' .  '&nbsp;&nbsp;' . '|'  . '____' ;
+
+		echo '<script type="text/javascript" src="certificados.js"></script>';
+		echo '<h2 style="color: #000066">Cadeias de certificados AC\'s configuradas:</h2>';	
+		echo '<div style="border: #000000 1px solid; overflow: auto; width: 770px; height: 400px; white-space: pre;  padding: 3px; " >';
+		echo '<pre>';
+		foreach($NOVO as $K => $V)
+			{
+				if($tab_certs[$K]['fim_validade'])
+					{
+						$msg =  $tab_certs[$K]['fim_validade'];
+					}
+				else
+					{
+						$msg =  '<font color="FF0000" size="4"><b>Certificado ausente da cadeia.</b></font> ';
+					}
+				echo '<br/><font color="0000FF" size="4"><b><a href="javascript:Um_Certificado(\''. $tab_certs[$K]['item']  . ' - ' . $K .'\')" style="text-decoration: none" >' . $K . '</a></b></font>  ' . $msg . '<br/>';
+				if(is_array($V))
+					{
+						$num = count($V);
+						$item = 0;
+						foreach($V as $K1 => $V1)
+							{
+								$item = $item + 1;
+								echo $prefixo0 . '<br/>';
+								if($tab_certs[$K1]['fim_validade'])
+									{
+										$msg =  $tab_certs[$K1]['fim_validade'];
+									}
+								else
+									{
+										$msg =  '<font color="FF0000" ><b>Certificado ausente da cadeia.</b></font> ';
+									}
+								echo $prefixo1 .  '<font color="#000000" ><a href="javascript:Um_Certificado(\''. $tab_certs[$K1]['item']  . ' - ' . $K1 .'\')" style="text-decoration: none" >' . $K1 . '</a></font> ' .  '  ' . $msg . '<br/>';
+								if(is_array($V1))
+									{
+										foreach($V1 as $K2 => $V2)
+											{
+												if($tab_certs[$K1]['fim_validade'])
+													{
+														$msg =  $tab_certs[$K1]['fim_validade'];
+													}
+												else
+													{
+														$msg =  '<font color="FF0000" ><b>Certificado ausente da cadeia.</b></font> ';
+													}
+												if($num>$item)
+													{
+														echo  $prefixo2 . '<br/>';
+														echo$prefixo3 . '<font color="#000000" ><a href="javascript:Um_Certificado(\''. $tab_certs[$K2]['item']  . ' - ' . $K2 .'\')" style="text-decoration: none" >' . $K2 . '</a></font> ' .  '  ' . $msg . '<br/>';
+													}
+												else
+													{
+														echo  $prefixo2A . '<br/>';
+														echo $prefixo3A .  '<font color="#000000" ><a href="javascript:Um_Certificado(\''. $tab_certs[$K2]['item']  . ' - ' . $K2 .'\')" style="text-decoration: none" >' . $K2 . '</a></font> ' .  '  ' . $msg . '<br/>';										
+													}
+											}
+									}
+							}
+					}
+			}
+		echo '</pre>';
+		echo '</div><br/>';		
+		}
+	if($path1)
+		{
+			$Linhas = explode(chr(0x0A),file_get_contents($path1));
+			echo '<h2  style="color: #000066">LCR\'s configuradas:</h2>';	
+			echo '<table border ="1" style="margin-top: 8px; width: 770px">';
+			echo '<th nowrap align="left" style=" padding: 5px">Lista de Certificados revogados obtida em:</th><th nowrap align="left" style=" padding: 5px">Onde é salva a LCR:</th>';
+			foreach($Linhas as $linha)
+				{
+					if($linha[0] != '#' && $linha != '')
+						{
+							$c = explode(';', $linha);
+							$n = explode('/',$c[0]);
+							$f = $c[1] . $n[count($n)-1];
+							echo '<tr><td nowrap valign="top" style=" padding: 5px">' . $c[0] . '</td><td nowrap style=" padding: 5px">';
+							echo $f;
+							if(!is_file($f))
+								{
+									echo '<p style="margin-bottom: 5px"><b  style="color: #FF0000">Arquivo n&atilde;o localizado.</b></p>'; 
+								}
+							else
+								{
+									$data = file_get_contents($f);
+									$dados = Crl_parseASN($data);
+									echo '<br/><br/>Emitido por: ';
+									$aux = $dados[1][0][1][2][1]; // pega dados do emissor.
+									$aux = $aux[count($aux)-1];  // ultimo item he o do CN.....
+									echo $aux[1][1][1][1];
+									echo '<br/>Num. certificados: ';
+									$num = 0;
+									if(count($dados[1][0][1]) > 6)        // qtd de itens esperado he 7. o 6 contem os certificados revogados.
+										{
+											$num = count($dados[1][0][1][5][1]);  // pega o numero de certificados revogados na LCR.
+										}
+									echo $num; 
+									echo '<br/>LCR num. : ';
+									$oid_Num_crl = recupera_dados_oid($data,'2.5.29.20');  // oid que informa o numero de geracao da LCR.
+									$num = $oid_Num_crl[0][1][1][1];
+									if($num)
+										{
+											echo $num; 
+										}
+									else 
+										{
+											echo '0';
+										}
+									echo '<br>';
+									$di = data_hora($dados[1][0][1][3][1]);             // data, hora em que foi gerada a LCR.
+									$df = data_hora($dados[1][0][1][4][1]);		   // data, hora em que expira a LCR.							
+									if(gmdate("YmdHis") < $di)
+										{
+											$cor = 'style="color: #FF0000"';
+										}
+									else
+										{
+											$cor = 'style="color: #000066"';
+										}
+									echo '<p><b  ' . $cor . '>Gerada em : </b>' . substr($di,0,4) . '/' . substr($di,4,2) . '/' . substr($di,6,2) . '  -  ' . substr($di,8,2) . ':' . substr($di,10,2) . ':' . substr($di,12,2) . ' GMT</p>';
+									if(gmdate("YmdHis") > $df)
+										{
+											$cor = 'style="color: #FF0000" >Expirada em: ';
+										}
+									else
+										{
+											$cor = 'style="color: #000066" >Expira em: ';
+										}
+									echo '<p><b  ' . $cor . ' </b>' . substr($df,0,4) . '/' . substr($df,4,2) . '/' . substr($df,6,2) . '  -  ' . substr($df,8,2) . ':' . substr($df,10,2) . ':' . substr($df,12,2) . ' GMT</p>';									
+								}
+							echo  '</td></tr>';
+						}
+				}
+			echo '</table><br><br><br>';
+		}
+	
+
+		
+		
+	if($path2)
+		{
+			echo '<br><h2  style="color: #000066">Log da atualiza&ccedil;&atilde;o das LCR\'s:</h2>';	
+			echo '<div style="border: #000000 1px solid; overflow: auto; width: 770px; height:290px; white-space: pre; padding: 5px" >';
+			echo '<pre>';
+			if(is_file($path2))
+				{
+					$saida = array();
+					$ret = exec('cat ' . $path2 . ' | grep ' . date('Y-m-d') ,$saida);
+					foreach($saida as $linha)
+						{
+							echo $linha . chr(0x0A);
+						}
+				}
+			else
+				{
+					echo '<p style="margin-bottom: 5px"><b  style="color: #FF0000">Arquivo  ' . $path2 . '  n&atilde;o localizado.</b></p>'; 
+				}
+			echo '</pre>';
+			echo '</div><br><br>';
+		}
+?>
Index: /trunk/seguranca/vercert.php
===================================================================
--- /trunk/seguranca/vercert.php	(revision 1035)
+++ /trunk/seguranca/vercert.php	(revision 1035)
@@ -0,0 +1,240 @@
+<?php
+function item_para_uid($dados_do_certificado)
+	{
+/*
+// Exemplo do Array $dados_do_certificado padrao ICP-BRASIL
+// O conteudo do array pode variar conforme a AC emissora.
+Array
+(
+    [SERIALNUMBER] => 2009031816232802
+    [EMISSOR_CAMINHO_COMPLETO] => Array
+        (
+            [C] => BR
+            [O] => ICP-Brasil
+            [OU] => CSPB-1
+            [CN] => HOMAutoridade Certificadora do SERPRO Final v2
+        )
+
+    [EMISSOR] => HOMAutoridade Certificadora do SERPRO Final v2
+    [INICIO_VALIDADE] => 20090318205216
+    [FIM_VALIDADE] => 20120317205216
+    [EXPIRADO] => 
+    [SUBJECT] => Array
+        (
+            [C] => BR
+            [O] => ICP-Brasil
+            [OU] => Pessoa Fisica A3
+            [CN] => CESAR VIANNA
+        )
+
+    [NOME] => CESAR VIANNA
+    [AUTHORITYKEYIDENTIFIER] => AE34F397BB05B1AA6CC3FD6C4F0E9129BBB61BE2
+    [KEYUSAGE] => Array
+        (
+            [digitalSignature] => 1
+            [nonRepudiation] => 1
+            [keyEncipherment] => 1
+        )
+
+    [EXTKEYUSAGE] => Array
+        (
+            [clientAuth] => 1.3.6.1.5.5.7.3.2
+            [emailProtection] => 1.3.6.1.5.5.7.3.4
+        )
+
+    [CA] => 
+    [CRLDISTRIBUTIONPOINTS] => Array
+        (
+            [0] => http://ccdhom.serpro.gov.br/lcr/serproacfv2.crl
+            [1] => http://ccdhom.serpro.gov.br/lcr/serproacfv3.crl
+            [2] => http://ccdhom.serpro.gov.br/lcr/serproacfv4.crl
+        )
+
+    [2.16.76.1.3.6] => Array
+        (
+            [CADINSS] => 000000000000
+        )
+
+    [CADINSS] => 000000000000
+    [2.16.76.1.3.5] => Array
+        (
+            [TITULO] => 000000000000
+            [ZONA] => 000
+            [SECAO] => 0000
+            [TITULO_CIDADE_UF] => 
+        )
+
+    [TITULO] => 000000000000
+    [ZONA] => 000
+    [SECAO] => 0000
+    [TITULO_CIDADE_UF] => 
+    [2.16.76.1.3.1] => Array
+        (
+            [NASCIMENTO] => 19081981
+            [CPF] => 12345678902
+            [NIS] => 12345678901
+            [RG] => 000201075150953
+            [ORGAOUF] => SSPRS
+        )
+
+    [NASCIMENTO] => 19081981
+    [CPF] =>  12345678902
+    [NIS] => 12345678901
+    [RG] => 000201075150953
+    [ORGAOUF] => SSPRS
+    [EMAIL] => cesar.vianna@pr.planalto.gov.br
+)
+*/	
+	
+		// Retorna o CPF para usar como uid.
+		return $dados_do_certificado['2.16.76.1.3.1']['CPF'];
+	}
+	
+	
+$GLOBALS['phpgw_info']['flags'] = array(
+		'disable_Template_class' => True,
+		'login'                  => True,
+		'currentapp'             => 'login',
+		'noheader'               => True
+	);
+
+if(!$_REQUEST['certificado'])
+{
+   echo '2'.chr(0x0D).chr(0x0A).'Certificado não foi apresentado.';
+   exit();
+}
+
+if(file_exists('../header.inc.php'))
+	{
+		include('../header.inc.php');
+	}
+else
+	{
+	        echo '1'.chr(0x0D).chr(0x0A).'Arquivo header.inc.php n&atilde;o foi localizado.';
+		exit();    
+	}
+    
+$ldap_context = $GLOBALS['phpgw_info']['server']['ldap_context'];
+$ldap_servidor = $GLOBALS['phpgw_info']['server']['ldap_host'];
+$ldap_dn = $GLOBALS['phpgw_info']['server']['ldap_root_dn'];
+$ldap_passwd = $GLOBALS['phpgw_info']['server']['ldap_root_pw'];
+
+require_once('classes/CertificadoB.php');
+require_once('classes/Verifica_Certificado.php');
+include('classes/Verifica_Certificado_conf.php');
+
+  # Transforma o certificado do formato PEM para o formato DER ...
+  function troca_espaco_por_mais($pem_data) 
+  {
+    $begin = "CERTIFICATE-----";
+    $end   = "-----END";
+    $aux = substr($pem_data, strpos($pem_data, $begin)+strlen($begin));    
+    $aux = substr($aux, 0, strpos($aux, $end));
+    $aux = strtr($aux,' ','+');
+    $aux = '-----BEGIN CERTIFICATE-----'.$aux.'-----END CERTIFICATE-----';
+    return $aux;
+   }
+ 
+
+$cert =str_replace(chr(0x0A).chr(0x0A),chr(0x0A),$_REQUEST['certificado']);
+$cert = troca_espaco_por_mais($cert);
+
+$c = new certificadoB();
+$c->certificado($cert);
+
+if (!$c->apresentado)
+{
+   echo '2'.chr(0x0D).chr(0x0A).'Certificado não foi apresentado.';
+   exit();
+}
+
+if (!$c->dados['CPF'])
+{
+   echo '2'.chr(0x0D).chr(0x0A).'Não foi possível obter o CPF do certificado apresentado.';
+   exit();
+}
+
+$b = new Verifica_Certificado($c->dados,$cert);
+
+// Testa se Certificado OK.
+if(!$b->status)
+{
+   $msg = '3'.chr(0x0D).chr(0x0A).$b->msgerro;
+
+   foreach($b->erros_ssl  as $linha)
+   {
+	$msg .= "\n" . $linha;
+   }
+
+   echo $msg;
+   exit();   
+}
+
+    $cc=ldap_connect($ldap_servidor); 
+
+    //  bind ..
+    $sr=ldap_bind($cc,$ldap_dn,$ldap_passwd);  
+
+    $filtro = 'uid='. item_para_uid($c->dados);
+
+    // Pesquisa CPF no RHDS/LDAP
+    $sr=ldap_search($cc, $ldap_context,$filtro);  
+
+    // Pega resultado ....
+    $info = ldap_get_entries($cc, $sr);
+  
+    // Tem de achar só uma entrada.....ao menos uma....
+    if($info["count"]!=1)
+    {
+	echo '4'.chr(0x0D).chr(0x0A).'Dados inválidos no diretório de usuários';	
+	ldap_close($cc);
+	exit();
+    }
+
+// A conta expresso tem de estar ativa....
+if($info[0]['phpgwaccountstatus'][0]!='A')
+    {
+	echo '5'.chr(0x0D).chr(0x0A).'Conta do usuario nao esta ativa no Expresso.';
+	ldap_close($cc);
+	exit();
+    }
+
+if($info[0]["cryptpassword"][0] && $info[0]["usercertificate"][0] && $cert == $info[0]["usercertificate"][0] )
+    {
+	echo '0'.chr(0x0D).chr(0x0A).$info[0]["uid"][0].chr(0x0D).chr(0x0A).$info[0]["cryptpassword"][0];
+	//echo '0' . "\n" . $info[0]["uid"][0] . "\n" . $info[0]["cryptpassword"][0];
+    }
+else
+    {
+        if(!$info[0]["usercertificate"][0] || $cert != $info[0]["usercertificate"][0])
+		{
+			$user_info = array();
+			$aux1 = $info[0]["dn"];
+			$user_info['usercertificate'] = $cert;
+			 if(isset($GLOBALS['phpgw_info']['server']['atributoexpiracao']))
+				{
+					if(substr($ldap_info['atributoexpiracao'],-1,1)=="Z")
+						{
+							###quando a data de expiracao estah no formato yyyymmddhhmmssZ
+							$user_info[$GLOBALS['phpgw_info']['server']['atributoexpiracao']] = '19800101000000Z';
+						}
+					else
+						{
+							###Outro atributo ldap que, assim como o phpgwaccounttype, tambem contem hora em formato unix
+							$user_info[$GLOBALS['phpgw_info']['server']['atributoexpiracao']] = '0';
+						}
+				}
+			else
+				{
+					$user_info['phpgwaccountexpires'] = '0';
+				}
+			ldap_modify($cc,$aux1,$user_info);
+			echo '6'.chr(0x0D).chr(0x0A).'Seu Certificado foi cadastrado. Sua senha foi expirada. Altere sua senha para concluir o processo.';
+		}
+	else
+		{
+			echo '6'.chr(0x0D).chr(0x0A).'Sua senha foi expirada. Altere sua senha para acessar o Expresso usando certificado digital.';
+		}
+    }
+ldap_close($cc);
+?>
Index: /trunk/seguranca/security_admin.php
===================================================================
--- /trunk/seguranca/security_admin.php	(revision 1035)
+++ /trunk/seguranca/security_admin.php	(revision 1035)
@@ -0,0 +1,16 @@
+<?php
+
+	$GLOBALS['phpgw_info'] = array();
+	$GLOBALS['phpgw_info']['flags']['currentapp'] = 'admin';
+	include('../header.inc.php');
+	$GLOBALS['phpgw_info']['flags']['app_header'] = lang('Admin') .' - ' . lang('CAs/CRLs Configuration ');
+
+        if (file_exists('security.php'))
+	  {
+	       include('security.php');
+	  }
+	else
+	  {
+	       echo '<div><h4>Dados para administra&ccedil;&atilde;o das CA\'s e CRL\'s n&atilde;o foram localizados.</h4></div>';
+	  }
+?>
